# aes.h File Reference

## Detailed Description

Copyright (C) 2006-2009, Paul Bakker <polarssl_maintainer at polarssl.org> All rights reserved.

Joined copyright on original XySSL code with: Christophe Devine

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

Definition in file aes.h.

Go to the source code of this file.

## Data Structures
struct | aes_context
| AES context structure. More...
## Defines
#define | AES_DECRYPT 0
#define | AES_ENCRYPT 1
#define | POLARSSL_ERR_AES_INVALID_KEY_LENGTH -0x0800
## Functions
void | aes_crypt_cbc (aes_context *ctx, int mode, int length, unsigned char iv[16], unsigned char *input, unsigned char *output)
| AES-CBC buffer encryption/decryption Length should be a multiple of the block size (16 bytes).
void | aes_crypt_cfb128 (aes_context *ctx, int mode, int length, int *iv_off, unsigned char iv[16], unsigned char *input, unsigned char *output)
| AES-CFB128 buffer encryption/decryption.
void | aes_crypt_ecb (aes_context *ctx, int mode, unsigned char input[16], unsigned char output[16])
| AES-ECB block encryption/decryption.
int | aes_self_test (int verbose)
| Checkup routine.
int | aes_setkey_dec (aes_context *ctx, unsigned char *key, int keysize)
| AES key schedule (decryption).
int | aes_setkey_enc (aes_context *ctx, unsigned char *key, int keysize)
| AES key schedule (encryption).

## Define Documentation

#define AES_DECRYPT 0

Definition at line 27 of file aes.h.

#define AES_ENCRYPT 1

Definition at line 26 of file aes.h.

#define POLARSSL_ERR_AES_INVALID_KEY_LENGTH -0x0800

Definition at line 29 of file aes.h.

## Function Documentation

void aes_crypt_cbc | ( | aes_context * | ctx,
|  | int | mode,
|  | int | length,
|  | unsigned char | iv[16],
|  | unsigned char * | input,
|  | unsigned char * | output |
| ) |  |  |

AES-CBC buffer encryption/decryption Length should be a multiple of the block size (16 bytes).

Parameters:

  | ctx | AES context
  | mode | AES_ENCRYPT or AES_DECRYPT
  | length | length of the input data
  | iv | initialization vector (updated after use)
  | input | buffer holding the input data
  | output | buffer holding the output data

void aes_crypt_cfb128 | ( | aes_context * | ctx,
|  | int | mode,
|  | int | length,
|  | int * | iv_off,
|  | unsigned char | iv[16],
|  | unsigned char * | input,
|  | unsigned char * | output |
| ) |  |  |

AES-CFB128 buffer encryption/decryption.

Parameters:

  | ctx | AES context
  | mode | AES_ENCRYPT or AES_DECRYPT
  | length | length of the input data
  | iv_off | offset in IV (updated after use)
  | iv | initialization vector (updated after use)
  | input | buffer holding the input data
  | output | buffer holding the output data

void aes_crypt_ecb | ( | aes_context * | ctx,
|  | int | mode,
|  | unsigned char | input[16],
|  | unsigned char | output[16] |
| ) |  |  |

AES-ECB block encryption/decryption.

Parameters:

  | ctx | AES context
  | mode | AES_ENCRYPT or AES_DECRYPT
  | input | 16-byte input block
  | output | 16-byte output block

int aes_self_test | ( | int | verbose | ) |

Checkup routine.

Returns:
  0 if successful, or 1 if the test failed

int aes_setkey_dec | ( | aes_context * | ctx,
|  | unsigned char * | key,
|  | int | keysize |
| ) |  |  |

AES key schedule (decryption).

Parameters:

  | ctx | AES context to be initialized
  | key | decryption key
  | keysize | must be 128, 192 or 256

Returns:
  0 if successful, or POLARSSL_ERR_AES_INVALID_KEY_LENGTH

int aes_setkey_enc | ( | aes_context * | ctx,
|  | unsigned char * | key,
|  | int | keysize |
| ) |  |  |

AES key schedule (encryption).

Parameters:

  | ctx | AES context to be initialized
  | key | encryption key
  | keysize | must be 128, 192 or 256

Returns:
  0 if successful, or POLARSSL_ERR_AES_INVALID_KEY_LENGTH